%define is_mandrake %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)

Name:       dxirc
Version:    1.30.0
Summary: dxirc - simple IRC client
Release: 1
License: GPL
Group: Applications/Communications
Source: %{name}-%{version}.tar.gz
Packager: David Vachulka <arch_dvx@users.sourceforge.net>
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: cmake

%description
dxirc - simple IRC client.

%package data
Summary: dxirc - simple IRC client, data files
BuildRequires: gettext

%description data
dxirc - simple IRC client, data files.

%package fox
Summary: dxirc - simple IRC client with FOX toolkit GUI
Requires: dxirc-data
%if %is_mandrake
BuildRequires: libfox1.6-devel libpng-devel >= 1.2 libopenssl-devel liblua-devel
%else
BuildRequires: fox-devel >= 1.6 libpng-devel >= 1.2 openssl-devel lua-devel
%endif

%description fox
dxirc - simple IRC client with FOX toolkit GUI.

%package qt
Summary: dxirc - simple IRC client with Qt GUI
Requires: libpurplemm dxirc-data
%if %is_mandrake
BuildRequires: libqt5-qtbase-devel libqt5multimedia-devel liblua-devel
%endif
%if %is_fedora
BuildRequires: qt5-qtbase-devel qt5-qtmultimedia-devel lua-devel
%else
BuildRequires: libqt5-qtbase-devel libqt5-qtmultimedia-devel lua-devel
%endif

%description qt
dxirc - simple IRC client with Qt GUI.

%prep
%setup -q

%build
LIBSUFFIX=$(echo "%{_lib}"|sed 's/^lib//')
mkdir build
pushd build
cmake \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DLIB_SUFFIX="$LIBSUFFIX" \
    ..
make
popd #build

%install
pushd build
%make_install
popd #build

%clean
rm -rf %{buildroot}

%files data
%defattr(-,root,root)
%{_datadir}/icons/*
%{_datadir}/dxirc/*
%{_datadir}/locale/*

%files fox
%defattr(-,root,root)
%{_bindir}/dxirc-fox
%{_datadir}/applications/dxirc-fox.desktop

%files qt
%defattr(-,root,root)
%{_bindir}/dxirc-qt
%{_datadir}/applications/dxirc-qt.desktop

