/*
 *      configdialog.h
 *
 *      Copyright 2008 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#include "defs.h"
#include "fxext.h"
#include "tabitems/dxtabbook.h"
#ifndef PREFERENCES_H
#include "preferences.h"
#endif

const ColorTheme ColorThemes[]={
//|--------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------|
//|        Name        |        Base      |       Border     |       Back       |      Fore        |      Selback     |      Selfore     |      Tipback     |     Tipfore      |      Menuback    |      Menufore    |      Notifyback  |      Notifyfore  |
//|--------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------+------------------|
  {"FOX"               ,FXRGB(212,208,200),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 36,106),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 36,106),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Gnome"             ,FXRGB(214,215,214),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Atlas Green"       ,FXRGB(175,180,159),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(111,122, 99),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(111,122, 99),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"BeOS"              ,FXRGB(217,217,217),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Blue Slate"        ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Black and White"   ,FXRGB(  8,  8,  8),FXRGB( 77, 77, 77),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,255),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,255),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"CDE"               ,FXRGB(156,153,156),FXRGB(  0,  0,  0),FXRGB(131,129,131),FXRGB(255,255,255),FXRGB( 49, 97,131),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 49, 97,131),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Digital CDE"       ,FXRGB( 74,121,131),FXRGB(  0,  0,  0),FXRGB( 55, 77, 78),FXRGB(255,255,255),FXRGB( 82,102,115),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 82,102,115),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Dark Blue"         ,FXRGB( 66,103,148),FXRGB(  0,  0,  0),FXRGB(  0, 42, 78),FXRGB(255,255,255),FXRGB( 92,179,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 92,179,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Desert FOX"        ,FXRGB(214,205,187),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(128,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(128,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"EveX"              ,FXRGB(230,222,220),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Galaxy"            ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"iMac"              ,FXRGB(205,206,205),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 1"             ,FXRGB(192,192,192),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 2"             ,FXRGB(220,220,220),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 10, 95,137),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"KDE 3"             ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(255,221,118),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(255,221,118),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik"           ,FXRGB(234,233,232),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(169,209,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(169,209,255),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik Emerald"   ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(134,204,134),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(134,204,134),FXRGB(  0,  0,  0),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Keramik White"     ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Mandrake"          ,FXRGB(230,231,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 33, 68,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 33, 68,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Media Peach"       ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Next"              ,FXRGB(168,168,168),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Obsidian Coast"    ,FXRGB( 48, 47, 47),FXRGB(  0,  0,  0),FXRGB( 32, 31, 31),FXRGB(224,223,220),FXRGB( 24, 72,128),FXRGB(255,255,255),FXRGB( 16, 48, 80),FXRGB(196,209,224),FXRGB( 24, 72,128),FXRGB(255,255,255),FXRGB( 16, 48, 80),FXRGB(196,209,224)},
  {"Pale Gray"         ,FXRGB(214,214,214),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Plastik"           ,FXRGB(239,239,239),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(103,141,178),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Pumpkin"           ,FXRGB(238,216,174),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(205,133, 63),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(205,133, 63),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond 95"        ,FXRGB(195,195,195),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0,  0,128),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond 2000"      ,FXRGB(212,208,200),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(  0, 36,104),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(  0, 36,104),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Redmond XP"        ,FXRGB(238,238,230),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 74,121,205),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 74,121,205),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Solaris"           ,FXRGB(174,178,195),FXRGB(  0,  0,  0),FXRGB(147,151,165),FXRGB(  0,  0,  0),FXRGB(113,139,165),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(113,139,165),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Storm"             ,FXRGB(192,192,192),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB(139,  0,139),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB(139,  0,139),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Sea Sky"           ,FXRGB(165,178,198),FXRGB(  0,  0,  0),FXRGB(255,255,255),FXRGB(  0,  0,  0),FXRGB( 49,101,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0),FXRGB( 49,101,156),FXRGB(255,255,255),FXRGB(255,255,225),FXRGB(  0,  0,  0)},
  {"Wonton Soup"       ,FXRGB( 71, 76, 86),FXRGB(  0,  0,  0),FXRGB( 58, 62, 70),FXRGB(182,193,208),FXRGB(117,133,153),FXRGB(209,225,244),FXRGB(182,193,208),FXRGB( 42, 44, 48),FXRGB(117,133,153),FXRGB(209,225,244),FXRGB(182,193,208),FXRGB( 42, 44, 48)},
};

const FXint numThemes=ARRAYNUMBER(ColorThemes);

class ConfigDialog: public FXDialogBox
{
    FXDECLARE(ConfigDialog)
    public:
        ConfigDialog(FXMainWindow *owner);
        virtual ~ConfigDialog();

        long onCommandsSelected(FXObject*,FXSelector,void*);
        long onCommandsDeselected(FXObject*,FXSelector,void*);
        long onUsersSelected(FXObject*,FXSelector,void*);
        long onUsersDeselected(FXObject*,FXSelector,void*);
        long onUsersChanged(FXObject*,FXSelector,void*);
        long onFriendsSelected(FXObject*,FXSelector,void*);
        long onFriendsDeselected(FXObject*,FXSelector,void*);
        long onFriendsChanged(FXObject*,FXSelector,void*);
        long onAddCommand(FXObject*,FXSelector,void*);
        long onDeleteCommand(FXObject*,FXSelector,void*);
        long onAddUser(FXObject*,FXSelector,void*);
        long onModifyUser(FXObject*,FXSelector,void*);
        long onDeleteUser(FXObject*,FXSelector,void*);
        long onAddFriend(FXObject*,FXSelector,void*);
        long onModifyFriend(FXObject*,FXSelector,void*);
        long onDeleteFriend(FXObject*,FXSelector,void*);
        long onColor(FXObject*,FXSelector,void*);
        long onClose(FXObject*,FXSelector,void*);
        long onIconsChanged(FXObject*,FXSelector,void*);
        long onAddIcons(FXObject*,FXSelector,void*);
        long onDeleteIcons(FXObject*,FXSelector,void*);
        long onLogChanged(FXObject*,FXSelector,void*);
        long onNickCharChanged(FXObject*,FXSelector,void*);
        long onPathSelect(FXObject*,FXSelector,void*);
        long onAutoloadChanged(FXObject*,FXSelector,void*);
        long onAutoloadPathSelect(FXObject*,FXSelector,void*);
        long onTheme(FXObject*,FXSelector,void*);
        long onThemeColorChanged(FXObject*,FXSelector,void*);
        long onTabColorChanged(FXObject*,FXSelector,void*);
        long onFont(FXObject*,FXSelector,void*);
        long onIrcFont(FXObject*,FXSelector,void*);
        long onTray(FXObject*,FXSelector,void*);
        long onReconnect(FXObject*,FXSelector,void*);
        long onTabPosition(FXObject*,FXSelector,void*);
        long onNotifyPosition(FXObject*,FXSelector,void*);
        long onDccPathSelect(FXObject*,FXSelector,void*);
        long onDccPortD(FXObject*,FXSelector,void*);
        long onDccPortH(FXObject*,FXSelector,void*);
        long onSounds(FXObject*,FXSelector,void*);
        long onSoundConnect(FXObject*,FXSelector,void*);
        long onSoundDisconnect(FXObject*,FXSelector,void*);
        long onSoundMessage(FXObject*,FXSelector,void*);
        long onPlay(FXObject*,FXSelector,void*);
        long onSelectPath(FXObject*,FXSelector,void*);
        long onNotify(FXObject*,FXSelector,void*);
        long onShowNotify(FXObject*,FXSelector,void*);
        long onUseSmileys(FXObject*,FXSelector,void*);
        long onAddSmiley(FXObject*,FXSelector,void*);
        long onModifySmiley(FXObject*,FXSelector,void*);
        long onDeleteSmiley(FXObject*,FXSelector,void*);
        long onImportSmiley(FXObject*,FXSelector,void*);
        long onExportSmiley(FXObject*,FXSelector,void*);
        long onLoadLog(FXObject*,FXSelector,void*);
        long onMouseWheel(FXObject*,FXSelector,void*);
        long onModifyBindings(FXObject*,FXSelector,void*);
        long onRefreshBindings(FXObject*,FXSelector,void*);
    private:
        ConfigDialog():m_tabbook(NULL),m_commands(NULL),m_icons(NULL),m_smileys(NULL),m_users(NULL),m_friends(NULL),m_addCommand(NULL),m_deleteCommand(NULL),m_addUser(NULL),
        m_modifyUser(NULL),m_deleteUser(NULL),m_addTheme(NULL),m_deleteTheme(NULL),m_selectPath(NULL),m_selectAutoloadPath(NULL),m_addSmiley(NULL),m_modifySmiley(NULL),
        m_deleteSmiley(NULL),m_importSmiley(NULL),m_exportSmiley(NULL),m_icon1(NULL),m_icon2(NULL),m_icon3(NULL),m_icon4(NULL),m_icon5(NULL),m_icon6(NULL),m_icon7(NULL),
        m_fontButton(NULL),m_ircfontButton(NULL),m_addFriend(NULL),m_modifyFriend(NULL),m_deleteFriend(NULL),m_closeToTrayButton(NULL),m_checkConnect(NULL),m_checkDisconnect(NULL),
        m_checkMessage(NULL),m_checkNotifyConnect(NULL),m_checkNotifyDisconnect(NULL),m_checkNotifyMessage(NULL),m_textTest(NULL),m_nickCharField(NULL),
        m_showImportwarning(FALSE),m_numberAttemptSpinner(NULL),m_delayAttemptSpinner(NULL),m_numberAttemptLabel(NULL),m_delayAttemptLabel(NULL),m_text(NULL),m_themes(NULL),
        m_selectConnect(NULL),m_selectDisconnect(NULL),m_selectMessage(NULL),m_playConnect(NULL),m_playDisconnect(NULL),m_playMessage(NULL),m_labelSelected(NULL),
        m_labelNocurrent(NULL),m_labelTip(NULL),m_label(NULL),m_vframe2(NULL),m_menuFrame(NULL),m_textFrame1(NULL),m_textFrame2(NULL),m_textFrame3(NULL),
        m_tabFrame(NULL),m_menuGroup(NULL),m_sep1(NULL),m_sep2(NULL),m_font(NULL),m_ircFont(NULL),m_listTabs(NULL),m_tabs(NULL),m_tab(NULL),m_unread(NULL),m_highlight(NULL),
        m_tabframe1(NULL),m_tabframe2(NULL),m_tabframe3(NULL),m_tabLabel1(NULL),m_tabLabel2(NULL),m_tabLabel3(NULL),m_owner(NULL),m_loadLogButton(NULL),m_loadLineSpinner(NULL),
        m_labelNotify(NULL),m_listNotifyPos(NULL)
        {}
        ConfigDialog(const ConfigDialog&);

        Preferences m_preferences;
        dxTabBook *m_tabbook;
        FXList *m_commands;
        FXList *m_icons;
        FXList *m_smileys;
        FXIconList *m_users;
        FXIconList *m_friends;
        dxEXButton *m_addCommand;
        dxEXButton *m_deleteCommand;
        dxEXButton *m_addUser;
        dxEXButton *m_modifyUser;
        dxEXButton *m_deleteUser;
        dxEXButton *m_addTheme;
        dxEXButton *m_deleteTheme;
        dxEXButton *m_selectPath;
        dxEXButton *m_selectAutoloadPath;
        dxEXButton *m_addSmiley;
        dxEXButton *m_modifySmiley;
        dxEXButton *m_deleteSmiley;
        dxEXButton *m_importSmiley;
        dxEXButton *m_exportSmiley;
        FXLabel *m_icon1;
        FXLabel *m_icon2;
        FXLabel *m_icon3;
        FXLabel *m_icon4;
        FXLabel *m_icon5;
        FXLabel *m_icon6;
        FXLabel *m_icon7;
        dxEXButton *m_fontButton;
        dxEXButton *m_ircfontButton;
        dxEXButton *m_addFriend;
        dxEXButton *m_modifyFriend;
        dxEXButton *m_deleteFriend;
        FXCheckButton *m_closeToTrayButton;
        FXCheckButton *m_checkConnect;
        FXCheckButton *m_checkDisconnect;
        FXCheckButton *m_checkMessage;
        FXCheckButton *m_checkNotifyConnect;
        FXCheckButton *m_checkNotifyDisconnect;
        FXCheckButton *m_checkNotifyMessage;
        FXTextField *m_textTest;
        FXTextField *m_nickCharField;
        FXString m_dccIP1;
        FXString m_dccIP2;
        FXString m_dccIP3;
        FXString m_dccIP4;
        FXbool m_showImportwarning;
        FXSpinner *m_numberAttemptSpinner;
        FXSpinner *m_delayAttemptSpinner;
        FXLabel *m_numberAttemptLabel;
        FXLabel *m_delayAttemptLabel;
        FXDataTarget m_targetIrccolorsText;
        FXDataTarget m_targetIrccolorsBack;
        FXDataTarget m_targetIrccolorsUser;
        FXDataTarget m_targetIrccolorsAction;
        FXDataTarget m_targetIrccolorsNotice;
        FXDataTarget m_targetIrccolorsError;
        FXDataTarget m_targetIrccolorsHilight;
        FXDataTarget m_targetIrccolorsLink;
        FXDataTarget m_targetIrccolorsMymsg;
        FXDataTarget m_targetIrccolorsLog;
        FXDataTarget m_targetUseTray;
        FXDataTarget m_targetLogging;
        FXDataTarget m_targetOwnServerWindow;
        FXDataTarget m_targetAutoload;
        FXHiliteStyle m_textStyle[8];
        FXText *m_text;
        ColorTheme m_themeCurrent;
        FXListBox *m_themes;
        FXDataTarget m_targetThemeBack;
        FXDataTarget m_targetThemeBase;
        FXDataTarget m_targetThemeBorder;
        FXDataTarget m_targetThemeFore;
        FXDataTarget m_targetThemeMenuback;
        FXDataTarget m_targetThemeMenufore;
        FXDataTarget m_targetThemeSelback;
        FXDataTarget m_targetThemeSelfore;
        FXDataTarget m_targetThemeTipback;
        FXDataTarget m_targetThemeTipfore;
        FXDataTarget m_targetSameCmd;
        FXDataTarget m_targetSameList;
        FXDataTarget m_targetColoredNick;
        FXDataTarget m_targetCloseToTray;
        FXDataTarget m_targetMaxAway;
        FXDataTarget m_targetReconnect;
        FXDataTarget m_targetNumberAttempt;
        FXDataTarget m_targetDelayAttempt;
        FXDataTarget m_targetDccPath;
        FXDataTarget m_targetLogPath;
        FXDataTarget m_targetAutoloadPath;
        FXDataTarget m_targetDccIP1;
        FXDataTarget m_targetDccIP2;
        FXDataTarget m_targetDccIP3;
        FXDataTarget m_targetDccIP4;
        FXDataTarget m_targetDccPortD;
        FXDataTarget m_targetDccPortH;
        FXDataTarget m_targetDccTimeout;
        FXDataTarget m_targetSound;
        FXDataTarget m_targetSoundConnect;
        FXDataTarget m_targetSoundDisconnect;
        FXDataTarget m_targetSoundMessage;
        FXDataTarget m_targetNotify;
        FXDataTarget m_targetNotifyConnect;
        FXDataTarget m_targetNotifyDisconnect;
        FXDataTarget m_targetNotifyMessage;
        FXDataTarget m_targetNotifyTray;
        FXDataTarget m_targetOneInstance;
        FXDataTarget m_targetPathConnect;
        FXDataTarget m_targetPathDisconnect;
        FXDataTarget m_targetPathMessage;
        FXDataTarget m_targetStripColors;
        FXDataTarget m_targetUseSmileys;
        FXDataTarget m_targetAutoDccChat;
        FXDataTarget m_targetAutoDccFile;
        FXDataTarget m_targetTrayColor;
        FXDataTarget m_targetUnreadColor;
        FXDataTarget m_targetHighlightColor;
        FXDataTarget m_targetDisableSortTabs;
        dxEXButton *m_selectConnect;
        dxEXButton *m_selectDisconnect;
        dxEXButton *m_selectMessage;
        dxEXButton *m_playConnect;
        dxEXButton *m_playDisconnect;
        dxEXButton *m_playMessage;
        FXLabel *m_labelSelected;
        FXLabel *m_labelNocurrent;
        FXLabel *m_labelTip;
        FXLabel *m_label;
        FXVerticalFrame *m_vframe2;
        FXVerticalFrame *m_menuFrame;
        FXLabel *m_menuLabels[3];
        FXHorizontalFrame *m_textFrame1;
        FXHorizontalFrame *m_textFrame2;
        FXHorizontalFrame *m_textFrame3;
        FXHorizontalFrame *m_tabFrame;
        FXGroupBox *m_menuGroup;
        FXSeparator *m_sep1;
        FXSeparator *m_sep2;
        FXFont *m_font;
        FXFont *m_ircFont;
        FXListBox *m_listTabs;
        dxTabBook *m_tabs;
        dxEXTabItem *m_tab;
        dxEXTabItem *m_unread;
        dxEXTabItem *m_highlight;
        FXVerticalFrame *m_tabframe1;
        FXVerticalFrame *m_tabframe2;
        FXVerticalFrame *m_tabframe3;
        FXLabel *m_tabLabel1;
        FXLabel *m_tabLabel2;
        FXLabel *m_tabLabel3;
        FXMainWindow *m_owner;
        FXDataTarget m_targetUseSpell;
        FXDataTarget m_targetLoadLog;
        FXDataTarget m_targetLoadLine;
        FXDataTarget m_targetSortUserMode;
        FXCheckButton *m_loadLogButton;
        FXSpinner *m_loadLineSpinner;
        FXDataTarget m_targetThemeNotifyback;
        FXDataTarget m_targetThemeNotifyfore;
        FXLabel *m_labelNotify;
        FXListBox *m_listNotifyPos;

        void fillCommnads();
        FXString fillCommandsCombo();
        void fillIcons();
        void fillUsers();
        void fillFriends();
        void fillThemes();
        void fillSmileys();
        void updateCommands();
        void updateThemesList();
        void updateNickIcons();
        void updateColors();
        void updateFont();
        void updateIrcFont();
        void updateTabPosition();
        FXbool themeExist(const FXString &ckdTheme);
        FXbool nickExist(const FXString &ckdNick, FXbool user=TRUE);
        FXbool smileyExist(const FXString &ckdSmiley);
        FXchar* enquote(FXchar* result, const FXchar* text);
        FXchar* dequote(FXchar* text) const;
        void createGeneralTab(dxTabBook *tabbook);
        void createLookTab(dxTabBook *tabbook);
        void createIrctextTab(dxTabBook *tabbook);
        void createNicklistTab(dxTabBook *tabbook);
        void createIgnoreTab(dxTabBook *tabbook);
        void createDccTab(dxTabBook *tabbook);
        void createNotificationTab(dxTabBook *tabbook);
        void createSmileysTab(dxTabBook *tabbook);
        void createKeybindingsTab(dxTabBook *tabbook);
};

class SmileyDialog: public FXDialogBox
{
    FXDECLARE(SmileyDialog)
public:
    SmileyDialog(FXWindow *owner, FXString title, FXString smiley, FXString path);
    virtual ~SmileyDialog();

    long onAccept(FXObject*,FXSelector,void*);
    long onCancel(FXObject*,FXSelector,void*);
    long onPath(FXObject*,FXSelector,void*);

    FXString getSmiley() { return m_smileyText->getText(); }
    FXString getPath() { return m_pathText->getText(); }
    FXbool iconExist();
    FXIcon* getIcon() const { return m_previewLabel->getIcon(); }
private:
    SmileyDialog():m_smileyText(NULL),m_pathText(NULL),m_pathButton(NULL),m_previewLabel(NULL)
    {}
    SmileyDialog(const SmileyDialog&);

    FXTextField *m_smileyText;
    FXTextField *m_pathText;
    dxEXButton *m_pathButton;
    FXLabel *m_previewLabel;
};

#endif /* CONFIGDIALOG_H */
