/*
 *      helpdialog.h
 *
 *      Copyright 2011 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef HELPDIALOG_H
#define HELPDIALOG_H

#include "fxext.h"

class HelpDialog: public FXDialogBox
{
    FXDECLARE(HelpDialog)
public:
    HelpDialog(FXMainWindow *owner);
    virtual ~HelpDialog();

    virtual void create();

    long onKeyPress(FXObject*,FXSelector,void*);
    long onViewLicense(FXObject*,FXSelector,void*);
private:
    HelpDialog():m_contents(NULL),m_buttonframe(NULL),m_textframe(NULL),m_text(NULL),
            m_buttonClose(NULL),m_buttonViewLicense(NULL),m_licenseShowed(false)
    {}
    HelpDialog(const HelpDialog& orig);

    FXVerticalFrame *m_contents;
    FXHorizontalFrame *m_buttonframe, *m_textframe;
    FXText *m_text;
    dxEXButton *m_buttonClose, *m_buttonViewLicense;
    bool m_licenseShowed;

    void loadFile(const FXString& file);
};

#endif  /* HELPDIALOG_H */

