#ifndef I18N_H
#define I18N_H

#ifdef HAVE_SETLOCALE
#include <locale.h>
#endif

#if ENABLE_NLS
#include <libintl.h>
#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)
#define _n(id1, id2, n) ngettext((const char*)id1, (const char*)id2, (unsigned long int)n)
#else
#define _(String) (String)
#define N_(String) (String)
#define _n(id1, id2, n) (const char*)id2
#endif

#endif
