/*
 *      ircitem.h
 *
 *      Copyright 2014 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef IRCITEM_H
#define IRCITEM_H

#include <QStandardItem>
#include <QItemDelegate>
#include <QPainter>
#include "defs.h"

class IrcItem : public QStandardItem
{
public:
    enum UserRoles {
        RMode = Qt::UserRole+2,
        RAway
    };

    IrcItem(const QString &nick, UserMode mode);

    void setNick(const QString &nick);
    QString getNick();
    void setMode(UserMode mode);
    UserMode getMode();
    void setAway(bool away);
    bool getAway();
    void updateTooltip(NickInfo nick);
    void updateIconTheme();
};

class IrcItemDelegate : public QItemDelegate
{
public:
    IrcItemDelegate();
    QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const;
    void paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const;
};

#endif // IRCITEM_H
